//
//  BPContact.h
//  BuddyPop
//
//  Created by Yann Bizeul on Sun May 16 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AddressBook/AddressBook.h>
#import <AddressBook/ABAddressBookC.h>;
#import <ABPersonAdditions.h>;
#import "AddressBookAdditions.h"
#import "NSCalendarDateAdditions.h"
#import "NSStringAdditions.h"

@interface BPContact : NSObject {
    ABPerson *person;
}
+ (BPContact*)contactWithNumber:(NSString*)aNumber;
+ (NSDictionary*)contactDictionaryWithNumber:(NSString*)aNumber;
+ (NSArray*)namePropertiesOrder;
+ (NSString*)addressesFormat;
- (NSString*)addressesFormat:(NSString*)countryCode;
+ (BPContact*)lastContact;

- (id)initWithABPerson:(ABPerson*)aPerson;
- (ABPerson*)person;
//- (NSImage*)statusIcon;
- (NSImage*)picture;
- (NSImage*)smallPicture;
- (NSString*)fullName;
- (NSString*)valueForProperty:(NSString*)key;
- (NSString*)valueForProperty:(NSString*)key identifier:(NSString*)anIdentifier;
- (NSArray*)multiValueArrayForProperty:(NSString*)property;
- (NSArray*)multiValueArrayForProperty:(NSString*)property withMessengerLabels:(BOOL)flag;
- (NSString*)valueForMultiValueProperty:(NSString*)key identifier:(NSString*)identifier;
- (NSString*)uniqueId;
//- (BOOL)isOnline;
//- (void)startChat;
- (NSDictionary*)_messengersLabels;
- (BOOL)showAsCompany;
#pragma mark -
#pragma mark AddressBook integration
- (void)openInAddressBook;
- (void)editInAddressBook;
- (BOOL)isABRunning;

//- (void)startAudioChat;
@end