//
//  BPContactController.h
//  BuddyPop
//
//  Created by Yann Bizeul on Wed May 12 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AddressBook/AddressBook.h>
#import "BPSearchEngine.h"
#import "BPContactView.h"
#import "BPWindow.h"
#import "ABPersonAdditions.h";
#import "NSColorAdditions.h"
#import "NSCalendarDateAdditions.h"
#import "NSViewAdditions.h"
#import "BPPropertyView.h"
#import "CenterView.h"

#define ATTRIBUTES_NAME 1
#define ATTRIBUTES_RTF_NAME 10
#define ATTRIBUTES_NICK 16
#define ATTRIBUTES_RTF_NICK 17
#define ATTRIBUTES_COMPANY 2 
#define ATTRIBUTES_RTF_ORGANIZATION 12
#define ATTRIBUTES_JOB 3
#define ATTRIBUTES_RTF_JOB 13
#define ATTRIBUTES_LABEL 4
#define ATTRIBUTES_RTF_LABEL 14
#define ATTRIBUTES_VALUE 5
#define ATTRIBUTES_RTF_VALUE 15
#define ATTRIBUTES_VALUE_HILIGHT 6

/*
@protocol BPContactControllerDelegate
- (void)contactControllerContactChanged:(id)contactController;
@end
*/
@interface BPContactController : NSObject {
//    IBOutlet NSObject<BPContactControllerDelegate> *delegate;
    BPContact *contact;
    IBOutlet  CenterView  *centerView;
    IBOutlet id window;
    NSParagraphStyle *attributesParagraphstyle;
    NSMutableAttributedString *RTFRepresentation;
    BPPropertyView *hilightedView;
    NSFont *tempFont;
}
+ (BPContactController*)sharedContactController;
- (void)setContact:(BPContact*)aContact;
- (BPContact*)contact;
- (void)forceUpdate;
- (void)appendString:(NSString*)aString withAttributes:(int)attributes;
- (void)appendString:(NSString*)aString withAttributes:(int)attributes cr:(BOOL)cr;
- (void)copy;
- (NSData*)RTFRepresentation;
- (NSString*)stringRepresentation;
- (NSDictionary*)attributes:(int)attr;
- (NSDictionary*)attributes:(int)attr lineBreak:(BOOL)flag;
- (NSFont*)tempFont;
- (NSMenu*)contextualMenu;
//- (void)dialNumber:(NSString*)aNumber withDialer:(Class)dialer;
@end
