//
//  BPSearchEngine.h
//  BuddyPop
//
//  Created by Yann Bizeul on Wed May 12 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AddressBook/AddressBook.h>
#import <AddressBook/ABAddressBookC.h>
#import "BPContact.h"

typedef enum {
    BPSearchEngineDirectionLeft,
    BPSearchEngineDirectionRight,
    BPSearchEngineDirectionNone
} BPSearchEngineDirection;

@protocol BPSearchEngineDelegate
- (void)searchEngine:(id)searchEngine resultIndexChanged: (int)resultIndex direction:(BPSearchEngineDirection)aDirection;
@end

@interface BPSearchEngine : NSObject {
    IBOutlet NSObject<BPSearchEngineDelegate> *delegate;
//    IBOutlet id resultLabel;
    IBOutlet id queryLabel;
    IBOutlet id input;
    
    ABAddressBook *AB;
    NSArray *propertyList;
    NSArray *lookupLabels;
    
    NSArray *persons;
//    NSArray *namePropertiesOrder;
    
    NSString *query;
    int resultIndex;
}
+ (BPSearchEngine*)sharedSearchEngine;
- (id)initShared;
- (unsigned)count;
- (ABPerson*)currentPerson;
- (BPContact*)currentResult;
- (NSArray*)results;
- (void)resetQuery;
- (void)forceCurrentPerson:(ABRecord*)aPerson;
- (void)setPeople:(NSArray*)anArray;

- (void)findMe;
- (void)next;
- (void)previous;
@end


