//
//  BuddyPopUI.h
//  BuddyPop
//
//  Created by Yann Bizeul on 29/09/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CaptionTextField.h"
#import "RollOverButton.h"
#import "BPButtonBar.h"
#import "BPContactView.h"

@interface BuddyPopUI : NSObject {
@private
    NSMutableArray *hiddenViews;
//    NSView *_tempMainView;
//    NSView *_tempContactInfosView;

    IBOutlet id mainView;
    IBOutlet CaptionTextField *captionField;
    BPContactView *contactView;
}
+ (id)sharedInstance;
- (NSView*)contactView;
- (void)setContactInfosView:(NSView*)aView;
- (void)restoreContactInfosView;
- (void)setContentView:(NSView*)aView forView:(NSView*)container;
- (void)restoreContentForView:(NSView*)container;

#pragma mark Caption
- (void)captionPush:(NSString*)aString;
- (void)captionPop;
- (void)captionReplace:(NSString*)aString sender:(id)sender;

#pragma mark Buttons
- (BOOL)addButton:(RollOverButton*)aButton side:(BPButtonSide)side;
- (BOOL)removeButton:(RollOverButton*)aButton;

#pragma mark Misc
- (void)disableKeyStrokes;
- (void)enableKeyStrokes;
@end
