//
//  Dialer.h
//  BuddyPop
//
//  Created by Yann Bizeul on Wed May 26 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "NSArrayAdditions.h"
#import "NSStringAdditions.h"
#import "NSCharacterSetAdditions.h"
#import "BPContact.h"
#import "PhoneNumber.h"

#define kDialingTypeTones 0
#define kDialingTypePulse 1
/** \brief This is the abstract class defining a Dialer object. It must be inherited
 *
 *  This class defined a dialer, the main goal is to provide basic methos to dial or cancel dialing.
 *  Note that the dialing operation itself is made in a nex thread.
 */
@interface Dialer : NSObject {
    BOOL CANCEL;	/**< If true, can be checked by the dialing thread if it should cancel dialing */
    NSString *number;	/**< This is the phone number to dial */
    NSDictionary *userInfo;
}
+ (id)sharedDialer;				///< return true if the dialer is available.
+ (BOOL)isAvailable;				///< return true if the dialer is available.
						///< If not, the menu will be grayed out
+ (BOOL)isReady;
+ (void)dial:(NSString*)aNumber;
- (void)setNumber:(NSString*)aNumber;
- (void)dialerWillStartDialing;
- (int)timeout;
+ (void)setUserInfo:(NSDictionary*)aDictionary;
- (void)setUserInfo:(NSDictionary*)aDictionary;
- (NSDictionary*)userInfo;
- (void)cancel;
+(void)cancel;
+ (void)setCountryCode:(NSString*)aString;
+ (NSString*)countryCode;
+ (void)setPrefix:(NSString*)aString;
+ (NSString*)prefix;
+ (void)setAreaCodes:(NSArray*)anArray;
+ (NSArray*)areaCodes;
+ (NSString*)areaCodesAsString;
+ (void)setAreaCodesAsString:(NSString*)areaCodes;
+ (void)setAlwaysDialAreaCode:(BOOL)state;
+ (BOOL)alwaysDialAreaCode;
+ (void)setLongPrefix:(NSString*)aString;
+ (NSString*)longPrefix;
+ (void)setIntlPrefix:(NSString*)aString;
+ (NSString*)intlPrefix;
+ (void)setEnableSpeaker:(BOOL)flag;
+ (BOOL)enableSpeaker;
+ (void)setDialingType:(int)type;
+ (int)dialingType;
+ (NSString*)fullNumber:(NSString*)aNumber;
+ (NSString*)localizedNumber:(NSString*)number;
+ localizedNumber:(NSString*)aNumber 
	   prefix:(NSString*)prefix
      countryCode:(NSString*)countryCode
	 areaCodes:(NSArray*)areaCodes
       longPrefix:(NSString*)longPrefix
       intlPrefix:(NSString*)intlPrefix;
@end