//
//  BTConnection.h
//  BuddyPop
//
//  Created by Yann Bizeul on Fri May 07 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <IOBluetooth/Bluetooth.h>
#import <IOBluetooth/objc/IOBluetoothDevice.h>
#import <IOBluetooth/IOBluetoothUtilities.h>
#import <IOBluetooth/objc/IOBluetoothSDPServiceRecord.h>
#import <IOBluetooth/objc/IOBluetoothRFCOMMChannel.h>
#import <IOBluetooth/objc/IOBluetoothSDPUUID.h>

#import <AddressBook/AddressBook.h>
#import <AddressBookAdditions.h>

#import "BTPhone.h"

// Notifications
#define BTPhoneConnected @"BTPhoneConnected"
#define BTPhoneConnecting @"BTPhoneConnecting"
#define BTPhoneDisconnected @"BTPhoneDisconnected"
#define BTPhoneStatusChanged @"BTPhoneStatusChanged"

#define BTPhoneAway @"BTPhoneAway"
#define BTPhoneBack @"BTPhoneBack"

#define BTPhoneInitialized @"BTPhoneInitialized"
// State constants

typedef enum {
    BTAdapterNotAvailable = 0x0,
    BTAdapterAvailable = 0x1
} BTAdapterState;

typedef enum {
	BTDeviceConnected = 0x0,
	BTDeviceConnecting = 0x1,
	BTDeviceDisconnected = 0x2,
	BTDeviceBusy = 0x3
} BTDeviceState;

@class BTPhone;
/*
typedef enum {
	kBTSerialReadyState,
	kBTSerialWaitingState,
	kBTSerialOfflineState,
	kBTIdleState
} BTSerialState;
*/
/*
@protocol BTConnectionDelegate
- (void)btDeviceConnected:(id)aConnection;
- (void)btConnectionFailed:(id)aConnection;
- (void)btPhoneStatusChanged:(NSDictionary*)aDictionary;

- (BOOL)respondsToSelector:(SEL)aSelector;
@end
*/
@interface BTConnection : NSObject{
    
//    IBOutlet id					btDialog;
    BTPhone						*phone;
    
    NSTimer						*retryTimer;
    BTDeviceState				previousState;
    IOBluetoothDevice           *device;
    IOBluetoothRFCOMMChannel	*mRFCOMMChannel;
    IOBluetoothUserNotification	*disconnectNotification;
	
    NSString	*lastSentString;
    
    BOOL	shouldClose;
    BOOL	state;
    BOOL reconnectAfterWakeUp;
	
    BOOL	DEBUG;
    
    NSMutableArray		*commandsBuffer;
    
    BOOL	userDesiredState;
    BOOL mRFCOMMChannelRetained;
	
    BOOL initialized;
	
	NSMutableArray *GMI;
	NSMutableArray *GMM;
}
+ (BTConnection*)sharedConnection;
+ (NSArray*)devicesWithService:(BluetoothClassOfDevice)service;
+ (IOBluetoothDevice*)pairedDeviceWithName:(NSString*)aName;

- (BTPhone*)phone;

+ (BOOL)bluetoothPresent;
+ (BOOL)bluetoothAvailable;
- (void)setUserDesiredState:(BOOL)flag;
- (void)connect;
- (void)disconnect;
- (BOOL)isConnected;
- (BTDeviceState)state;

- (void)setDevice:(NSString*)deviceID;
- (NSString*)deviceName;
- (NSString*)lastSentString;
- (void)sendString:(NSString*)aString;
- (void)sendString:(NSString*)aString force:(BOOL)force;
- (void)injectData:(NSData*)data;
@end